(*  Copyright (C) 1999 Greatis Software  *)
(*    web: http://www.greatissoft.com    *)
(*    e-mail: support@greatissoft.com    *)

program ver2to3;

uses
  Windows, IniFiles, Registry, Classes, SysUtils;

const
  SecName = 'Delphi Component''s Prefixes';
  FileName = 'Prefixes.lst';
  ConfigFileName = 'NameProp.ini';
  ConfigSecName = 'NameProp Configuration';
  ListSecName = 'NameProp History';
  MaxHistory=100;
  RegName = 'SOFTWARE\Greatis';
  RegSecName = 'NameProp';
  PrefixesSecName = RegSecName+'\Prefixes';
  HistorySecName = RegSecName+'\History';
  OptionsSecName = RegSecName+'\Options';

type
  TPrefix = string[3];

var
  i,Cnt,DlgLeft,DlgTop: Integer;
  List,History: TStringList;

procedure CreateList;
var
  i: Integer;
  L: TStringList;
begin
  List:=TStringList.Create;
  L:=TStringList.Create;
  with TIniFile.Create(FileName) do
  try
    ReadSectionValues(SecName,L);
    for i:=0 to Pred(L.Count) do
      List.AddObject(L.Names[i],Pointer(TPrefix(L.Values[L.Names[i]])));
  finally
    L.Free;
    Free;
  end;
end;

procedure FreeList;
var
  i: Integer;
begin
  with TRegIniFile.Create(RegName) do
  try
    with List do
    try
      for i:=0 to Pred(Count) do
        WriteString(PrefixesSecName,Strings[i],TPrefix(Objects[i]));
    finally
      Free;
    end;
  finally
    Free;
  end;
end;

begin
  if MessageBox(0,
    'This program will convert data from NameProp2 to NameProp3.'#13'Continue?',
    'ver2to3',MB_YESNO or MB_ICONQUESTION)<>IDYES then Halt;
  try
    CreateList;
    with TIniFile.Create(ConfigFileName) do
    try
      DlgLeft:=ReadInteger(OptionsSecName,'DlgLeft',200);
      DlgTop:=ReadInteger(OptionsSecName,'DlgTop',140);
      Cnt:=ReadInteger(ListSecName,'Count',0);
      History:=TStringList.Create;
      for i:=1 to Cnt do
        History.Add(ReadString(ListSecName,IntToStr(i),''));
    finally
      Free;
    end;
    with TRegIniFile.Create(RegName) do
    try
      WriteInteger(OptionsSecName,'DlgLeft',DlgLeft);
      WriteInteger(OptionsSecName,'DlgTop',DlgTop);
      WriteInteger(HistorySecName,'Count',History.Count);
      for i:=1 to History.Count do
        WriteString(HistorySecName,IntToStr(i),History[Pred(i)]);
      History.Free;
    finally
      Free;
    end;
    FreeList;
    MessageBox(0,'Data is succefully converted.','ver2to3',MB_OK or MB_ICONINFORMATION);
  except
    on E: Exception do
      MessageBox(0,PChar(E.Message),'ver2to3',MB_OK or MB_ICONHAND);
  end;
end.
